/// <reference types="node" />
import { chmod, close, copyFile, mkdir, open, readdir, readFile, rmdir, unlink, write, writeFile } from 'fs';
import { basename, dirname, join, normalize, resolve as pathResolve } from 'path';
import { promisify } from 'util';
export declare const closeAsync: typeof close.__promisify__;
export declare const chmodAsync: typeof chmod.__promisify__;
export declare const copyFileAsync: typeof copyFile.__promisify__;
export declare const mkdirAsync: typeof mkdir.__promisify__;
export declare const openAsync: typeof open.__promisify__;
export declare const readFileAsync: typeof readFile.__promisify__;
export declare const readDirAsync: typeof readdir.__promisify__;
export declare const rmdirAsync: typeof rmdir.__promisify__;
export declare const unlinkAsync: typeof unlink.__promisify__;
export declare const writeAsync: typeof write.__promisify__;
export declare const writeFileAsync: typeof writeFile.__promisify__;
export { basename, dirname, join, normalize, pathResolve, promisify, };
export { tmpdir } from 'os';
export declare function isPathAcessible(path: string): Promise<boolean>;
export declare function isDirExists(path: string): Promise<boolean>;
export declare function isFileExists(path: string): Promise<boolean>;
export declare function createDir(path: string): Promise<void>;
export declare function createFile(file: string, data: any, options?: WriteFileOptions): Promise<void>;
export declare function logger(...args: any[]): void;
export interface ExecFileOptions {
    cwd?: string;
    env?: object;
    encoding?: 'utf8' | string;
    timeout?: 0 | number;
    maxBuffer?: number;
    killSignal?: string;
    uid?: number;
    gid?: number;
    windowsHide?: boolean;
    windowsVerbatimArguments?: boolean;
}
export interface WriteFileOptions {
    encoding?: string | null;
    mode?: number;
    flag?: string;
}
export declare function assertNever(x: never): never;
/**
 * Remove directory recursively
 * @see https://stackoverflow.com/a/42505874/3027390
 */
export declare function rimraf(path: string): Promise<void>;
