/**
 * windows-window-controller
 * controll window by calling user32.ShowWindow from node via node-ffi
 *
 * @version 3.2.1
 * @author waiting
 * @license MIT
 * @link https://github.com/waitingsong/node-windows-window-controller#readme
 */

import{Callback}from"ffi";import{address,isNull,alloc,reinterpretUntilZeros}from"ref";import{User32,K,Config,DTypes,U}from"win32-api";const UC=User32.constants,filterWinRulesDefaults={titleExits:null,includeStyle:null,excludeStyle:null,includeExStyle:null,excludeExStyle:null},showFilterRulesDefaults={titleExits:!0,includeStyle:UC.WS_SYSMENU,excludeStyle:UC.WS_CHILD,includeExStyle:null,excludeExStyle:UC.WS_EX_TOOLWINDOW},knl32=K.load();function get_last_err_msg(){const e=knl32.GetLastError();let t="";if(e){const n=255,r=Buffer.alloc(n),s=4608,l=1033,i=knl32.FormatMessageW(s,null,e,l,r,n,null);t=i?e+": "+reinterpretUntilZeros(r,2).toString("ucs2"):`${e}: unknown error meeage`}return t}const user32=U.load(),taskConfig={tno:0,task:new Map},enumWindowsProc=Callback(DTypes.BOOL,[DTypes.HWND,DTypes.LPARAM],(e,t)=>{const n=taskConfig.task.get(t);if(!n)return console.error("enumWindowsProc() task not exists"),!0;switch(n.matchType){case"pid":{const t=alloc(DTypes.HINSTANCE),r=user32.GetWindowThreadProcessId(e,t);if(r){const r=t.readUInt32LE(0);r&&r===n.matchValue&&n.hwndSet.add(e)}else{const e=get_last_err_msg();e&&(n.errMsg+=","+e)}break}case"title":if(n.matchValue){const t=Buffer.alloc(254),r=user32.GetWindowTextW(e,t,254);if(r){const r=t.toString("ucs2");if(-1!==r.indexOf(n.matchValue)){const t=Buffer.alloc(4);user32.GetWindowThreadProcessId(e,t),n.pidSet.add(t.readUIntLE(0,4)),n.hwndSet.add(e)}}else{const e=get_last_err_msg();e&&(n.errMsg+=","+e)}}else n.hwndSet.add(e);break;case"hwnd":+n.matchValue===address(e)&&n.hwndSet.add(e);break;default:return!0}return!0});function validate_cmdshow(e){const t=!("number"!=typeof e||e<0);return t||console.error("hWnd value invalid: See: https://msdn.microsoft.com/en-us/library/windows/desktop/ms633548(v=vs.85).aspx"),t}function show_hide_one(e,t){return new Promise((n,r)=>(t=+t,Number.isNaN(t)||t<0?r("show_hide_one() params nCmdShow invalid: "+t):0!==t||user32.IsWindowVisible(e)?(user32.ShowWindow(e,t),void n(e)):n()))}function task_get_hwnds(e){let t;return Promise.race([new Promise(e=>{t=setTimeout(()=>{console.info("task_get_hwnds timeout failed"),e()},3e4)}),_get_hwnds(e)]).then(n=>{if(clearTimeout(t),e&&taskConfig.task.delete(e.tno),n&&Array.isArray(n)&&n.length)return n}).catch(n=>{clearTimeout(t),e&&taskConfig.task.delete(e.tno),console.error(n)})}function _get_hwnds(e){switch(null===e.matchType&&("string"==typeof e.matchValue?e.matchType="title":"number"==typeof e.matchValue&&(e.matchType="pid")),e.matchType){case"pid":if(!Number.isSafeInteger(e.matchValue))return Promise.resolve();break;case"title":case"hwnd":break;default:throw new Error("task.matchType value invalid")}return get_task_hwnd(e).then(e=>e).catch(e=>{console.error(e)})}function get_task_hwnd(e){return new Promise((t,n)=>{e?user32.EnumWindows.async(enumWindowsProc,e.tno,n=>{e.errMsg&&console.error(e.errMsg),t(Array.from(e.hwndSet)||[])}):t([])})}function filter_hwnd(e,t){t=Object.assign({},filterWinRulesDefaults,t);const n=new Set;for(const r of e)n.has(r)||_filter_hwnd(r,t)&&n.add(r);return[...n.keys()]}function _filter_hwnd(e,t){let n=user32.GetParent(e);return!!isNull(n)&&(n=user32.GetWindow(e,4),!!isNull(n)&&(!!validate_rule_title(e,t)&&(!!validate_rule_style(e,t)&&!!validate_rule_exstyle(e,t))))}function validate_rule_title(e,t){const n=Buffer.alloc(100);user32.GetWindowTextW(e,n,50);let r=reinterpretUntilZeros(n,2).toString("ucs2");return r&&(r=r.trim()),!0===t.titleExits?!!r:!1!==t.titleExits||!r}function validate_rule_style(e,t){const n=-16,r=Config._WIN64?user32.GetWindowLongPtrW(e,-16):user32.GetWindowLongW(e,-16);return(!t.includeStyle||!Number.isSafeInteger(t.includeStyle)||(r|t.includeStyle)===r)&&(!t.excludeStyle||!Number.isSafeInteger(t.excludeStyle)||(r|t.excludeStyle)!==r)}function validate_rule_exstyle(e,t){const n=-20,r=Config._WIN64?user32.GetWindowLongPtrW(e,-20):user32.GetWindowLongW(e,-20);return(!t.includeExStyle||!Number.isSafeInteger(t.includeExStyle)||(r|t.includeExStyle)===r)&&(!t.excludeExStyle||!Number.isSafeInteger(t.excludeExStyle)||(r|t.excludeExStyle)!==r)}function create_task(){const e=++taskConfig.tno,t={tno:e,matchType:null,matchValue:"",hwndSet:new Set,pidSet:new Set,errMsg:""};return taskConfig.task.set(e,t),t}const user32$1=U.load();function hide(e){const t=Object.assign({},filterWinRulesDefaults,e);return t.nCmdShow=0,proxy(t)}function show(e){const t=Object.assign({},showFilterRulesDefaults,e);return t&&null!==t.titleExits&&"boolean"==typeof t.titleExits||(t.titleExits=!0),proxy(t)}function proxy(e){const t=init_execret();return"undefined"!=typeof e.nCmdShow&&validate_cmdshow(e.nCmdShow)?get_hwnds(e).then(n=>{if(n&&n.length)for(const r of n)r&&!isNull(r)&&show_hide_one(r,e.nCmdShow).then(e=>e&&!isNull(e)&&t.hwnds.push(address(e))).catch(e=>{t.err=1,t.msg+="\n "+e})}).catch(e=>{t.err=1,t.msg+=e.toString()}).then(()=>t):(t.err=1,t.msg="value of nCmdShow invalid",Promise.resolve(t))}function get_hwnds(e){const t=create_task();return t.matchType=e.matchType,t.matchValue=e.matchValue,task_get_hwnds(t).then(t=>{if(t&&Array.isArray(t)&&t.length)return filter_hwnd(t,e)})}function kill(e){const t=init_execret();if("pid"===e.matchType){const n=+e.matchValue;return n<=0?(t.err=1,t.msg="pid value invalid",Promise.resolve(t)):(_kill(n),t.pids.push(n),Promise.resolve(t))}return"title"===e.matchType?new Promise(n=>{const r=create_task();return r.matchType=e.matchType,r.matchValue=e.matchValue,task_get_hwnds(r).then(()=>{if(r.pidSet.size)for(const e of r.pidSet)_kill(e)&&t.pids.push(e);else t.msg="the pid list to be killed empty, none title matched";n(t)})}):(t.err=1,t.msg="kill() matchType invalid",Promise.resolve(t))}function _kill(e){try{return process.kill(e,0)&&process.kill(e),!0}catch(e){console.error(e)}return!1}function init_execret(){return{err:0,msg:"",pids:[],hwnds:[]}}function retrieve_pointer_by_hwnd(e){const t=create_task();return t.matchType="hwnd",t.matchValue=e,task_get_hwnds(t).then(e=>{if(e&&e.length)return e[0]})}function parse_cli_opts(e){const t=Object.assign({},showFilterRulesDefaults);if(e.pid)t.matchType="pid",t.matchValue=+e.pid;else if(e.title)t.matchType="title",t.matchValue=e.title;else{if(!e.hwnd)return;t.matchType="hwnd",t.matchValue=e.hwnd}return"undefined"!=typeof e.status&&(t.nCmdShow=+e.status,console.assert("number"==typeof t.nCmdShow,"nCmdShow must typeof number")),t}function set_title(e,t){const n=init_execret();return get_hwnds(t).then(t=>{const r=Buffer.from(e.trim()+"\0","ucs2");if(t&&t.length)for(const e of t)e&&!isNull(e)&&(user32$1.SetWindowTextW(e,r),n.hwnds.push(address(e)))}).catch(e=>{n.err=1,n.msg+=e.toString()}).then(()=>n)}export{validate_cmdshow,hide,show,get_hwnds,kill,parse_cli_opts,retrieve_pointer_by_hwnd,set_title,filterWinRulesDefaults,showFilterRulesDefaults};
//# sourceMappingURL=index.esm.min.js.map
